# PostgreSQL

## Supported Ingestion Methods

* Full
* Incremental
  * It is highly recommended that a non-clustered, non-unique index on the column used for incremental queries
* Change Data Capture (CDC)

For more information on ingestion methods, [click here](/data-sources/ingestion-methods.md).

## Enable Change Data Capture (CDC)

### Configure server-level settings

1. Set `wal_level = logical`
2. Set `max_replication_slots = #` (any number greater than 1, usually at least 10).

### Create a dedicated replication slot

```
SELECT pg_create_logical_replication_slot('verb_replication_slot', 'test_decoding');
```

### Grant permissions to user

```
ALTER USER <user> WITH REPLICATION;
GRANT SELECT ON ALL TABLES IN SCHEMA <schema> TO <user>;
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.verbdata.com/data-sources/database-engines/postgresql.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
